=begin
TIG (c) 2010 - 2013
SKMtools_loader.rb
loads all .rb files in the SKMtools folder
Version:
1.2 20101212 Updated to use absolute path NOT relative.
1.3 20130827 Temp folder use etc added...
1.4 20130828 Typo in ImageTrimmer fixed.
1.5 20130830 Typo in 'loader'.rb name corrected.
2.0 20160921 UTF-8 file encoding in JARs, for ImageTrimmer accented file paths.
=end
require('sketchup.rb')
###
module SKMtools
	VERSION="2.0"
	NAME="SKMtools"
	def self.encoder(txt) ### SKMtools.encoder( txt )
	#puts
	#p txt
	#puts
	 begin
		txt = txt.dup.force_encoding('UTF-8')
		#p txt
		return txt
	 rescue
	  #p 666
		return txt
	 end
	end
	PLUGINS=self.encoder(File.dirname(__FILE__))
	FOLDER=File.expand_path(File.join(PLUGINS, NAME))
	###
	HOME=File.expand_path( (begin;ENV['HOME'].dup.force_encoding('UTF-8');rescue;ENV['HOME'];end) || (begin;ENV['HOMEPATH'].dup.force_encoding('UTF-8');rescue;ENV['HOMEPATH'];end) || (begin;ENV['HOMEDRIVE'].dup.force_encoding('UTF-8');rescue;ENV['HOMEDRIVE'];end) )
	DESKTOP=File.join(HOME, "Desktop")
	###
	tmp=''
	[(begin;Sketchup.temp_dir;rescue;'!';end), 
	(begin;ENV['TEMP'].dup.force_encoding('UTF-8');rescue;ENV['TEMP'];end), 
	(begin;ENV['TMP'].dup.force_encoding('UTF-8');rescue;ENV['TMP'];end), 
	(begin;ENV['TMPDIR'].dup.force_encoding('UTF-8');rescue;ENV['TMPDIR'];end), 
	(begin;ENV['USERPROFILE'].dup.force_encoding('UTF-8');rescue;ENV['USERPROFILE'];end), 
	HOME, 
	DESKTOP, 
	FOLDER, 
	PLUGINS, 
	Dir.pwd, 
	'C:/Temp', 
	'/tmp'
	].each{|d|
		if d && File.directory?(d) && File.writable?(d)
			tmp = File.expand_path(d)
			break
		end
    }
	###
	TEMP = File.join(tmp, NAME)
	begin ### allows for false File.exist? failure with non-ASCII etc
		Dir.mkdir(TEMP)
	rescue
	end
	### load...
	begin
		Dir.entries(FOLDER).each{|r|
			next unless File.extname(r).downcase == '.rb' || File.extname(r).downcase == '.rbs'
			Sketchup::require(File.join(FOLDER, r)) ### load it
		}
	rescue
	end
	### tidy
	deletions=false
	Dir.entries(PLUGINS).each{|r|
		if r=~/^SKMtools_loader.rb/ || r=~/^SKMtool.rb/
			File.delete(File.join(PLUGINS, r))
			deletions=true
		end
	}
	UI.messagebox("Updated SKMtools need a SketchUp Restart,\nsome older files have been removed...") if deletions
	###
end#module
###