=begin
TIG (c) 2010 - 2013
  All Rights Reserved.
  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED 
  WARRANTIES,INCLUDING,WITHOUT LIMITATION,THE IMPLIED WARRANTIES OF 
  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
###########################################################################
  gifxtractor.rb
###########################################################################
Loaded by SKMtools_loader.rb in the ../Plugins/ folder.
Adds a new tool:
  gifxtractor(path_gif)
It requires GIFxtractor.jar in the same folder.
It extracts all of the frames from an animated GIF file as PNG files into a 
folder...
To use it type
 gifxtractor("C:\\Temp\\My Test.gif")
It makes a new folder called "C:\\Temp\\My_Test" which will receive a 
series of new PNG files of of the frames named thus:
My_Test00001.png, My_Test00002.png, My_Test00003.png... My_Test00999.png etc.
If opens the new folder if it exists.
It also returns the path to this new folder or 'nil' otherwise.
###########################################################################
Donations:
  By Paypal.com to info @ revitrev.org
###########################################################################   
Version:
1.0 20101213 First issue
1.1 20101222 Glitch with MAC file paths addressed.
1.2 20110213 MAC jar execution addressed.
1.3 20130827 Temp folders fixed.
###########################################################################
=end
###
require('sketchup.rb')
###

def gifxtractor(path="")
  if ! path.class==String
    path=""
  end#if
  ###
	path = SKMtools.encoder(path)
	###
  if path==""
    puts "Usage: gifxtractor(path_gif)"
    return nil
  end#if
  if ! File.exist?(path)
    puts "Usage: gifxtractor(path_gif)"
    puts "File '#{path}' was not found."
    return nil
  end#if
  if ! File.ftype(path)=="file"
    puts "gifxtractor(path_gif)"
    puts "'#{path}' is not a 'File'."
    return nil
  end#if
  if ! File.extname(path).downcase==".gif"
    puts "gifxtractor(path_gif)"
    puts "File '#{path}' is not a 'GIF'."
    return nil
  end#if
  ###
  pc=false
  pc=true if RUBY_PLATFORM =~ /mswin|mingw/
  fol=SKMtools::FOLDER
  dir=SKMtools::TEMP
  ###
  basename=File.basename(path, ".*").gsub(/[^A-Za-z0-9_-]/,"_")
  folder=File.join(File.dirname(path), basename)
  folder.tr!("/","\\") if pc
  Dir.mkdir(folder) if not File.exist?(folder)
  return nil if not File.exist?(folder)
  ###
  fromini=File.join(dir, "from.ini")
  path.tr!("/","\\") if pc
  file=File.new(fromini, "w")
    file.write(path)
  file.close
  ###
  toini=File.join(dir, "to.ini")
  topath=File.join(folder, basename)
  topath.tr!("/","\\") if pc
  file=File.new(toini, "w")
    file.write(topath)
  file.close
  ###
  jar=File.join(fol, "GIFxtractor.jar").tr("\\","/")
  jartemp=File.join(dir, "GIFxtractor.jar").tr("\\","/")
  ###
  file=File.open(jar, "rb")
	file.binmode
	data=file.read
  file.close
  ###
  file=File.open(jartemp, "wb")
	file.binmode
	file.write(data)
  file.close
  ###
  jar=jartemp
  ###
  pwd=Dir.pwd
  Dir.chdir(dir)
    File.chmod(0777, jar) unless pc
    if jar[0].chr=="/"
        jar="file:#{jar}"
    else
        jar="file:/#{jar}"
    end#if
    UI.openURL(jar)###########################
  Dir.chdir(pwd)
  UI.openURL("file:/#{folder}") ############################
  ###
  File.delete(fromini) if File.exist?(fromini)
  File.delete(toini) if File.exist?(toini)
  return folder
  ###
end#def
###
