=begin
TIG (c) 2011 - 2013
  All Rights Reserved.
  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED 
  WARRANTIES,INCLUDING,WITHOUT LIMITATION,THE IMPLIED WARRANTIES OF 
  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
###########################################################################
  pngwhite2transparent.rb
###########################################################################
Loaded by SKMtools_loader.rb in the ../Plugins/ folder.
Adds a new tool:
  pngwhite2transparent(folder_of_pngs)
It needs PNGwhite2transparent.jar in the same folder.
To use it type in the Ruby Console
  pngwhite2transparent 'C:/Temp/MyPNGsFolder'
It makes a new folder
  C:/Temp/MyPNGsFolder/PNGwhite2transparent 
which will receive copies of all pf the PNG files in the folder.
These PNG file copies are processed so 'pure white' pixels [255,255,255] 
are all made 'fully transparent'.
If opens this new folder on completion.
It also returns the path to this new folder [or 'nil'].
For example: ensure your scenes have a pure white background, then export 
them as an animation as multiple individual PNG files, this tool then 
allows you to remove the backgrounds - then in so any 'animation' you 
assemble [e.g. GIF] you have a 'see-through' background...
###########################################################################
Donations:
  By Paypal.com to info @ revitrev.org
###########################################################################   
Version:
1.0 20110121 First issue.
1.1 20110121 Transparent color now 'white'.
1.2 20110213 MAC jar execution addressed.
1.3 20130827 Temp folder resolved.
###########################################################################
=end
###
require('sketchup.rb')
###

def pngwhite2transparent(path="")
  ###
  if ! path.class==String
    path=""
  end#if
  if path==""
    puts "Usage: pngwhite2transparent(folder_of_pngs)"
    return nil
  end#if
	###
	path = SKMtools.encoder(path)
	###
  if ! File.exist?(path)
    puts "Usage: pngwhite2transparent(folder_of_pngs)"
    puts "File '"+path+"' was not found."
    return nil
  end#if
  if ! File.ftype(path)=="directory"
    puts "pngwhite2transparent(folder_of_pngs)"
    puts "'"+path+"' is not a 'Folder'."
    return nil
  end#if
  ###
  pc=false
  pc=true if RUBY_PLATFORM =~ /mswin|mingw/
    fol=SKMtools::FOLDER
	dir=SKMtools::TEMP
	  begin
		Dir.mkdir(dir)
	  rescue
	  end
	jar=File.join(dir, "PNGwhite2transparent.jar").tr("\\","/")
	jartemp=File.join(dir, "PNGwhite2transparent.jar").tr("\\","/")
	  ###
	  file=File.open(jar, "rb")
		file.binmode
		data=file.read
	  file.close
	  ###
	  file=File.open(jartemp, "wb")
		file.binmode
		file.write(data)
	  file.close
	  ###
	  jar=jartemp
  ###
  folder=File.join(path, 'PNGwhite2transparent')
  folder.tr!("/","\\") if pc
  Dir.mkdir(folder) if not File.exist?(folder)
  return nil if not File.exist?(folder)
  ### copy files over
  pngs=[]
  Dir.entries(path).each{|e|pngs << e if File.extname(e).downcase=='.png'}
  ###process all png's in folder
  fromini=File.join(dir, "from.ini")
  toini=File.join(dir, "to.ini")
  fpath=""
  tpath=""
  ctr='1'
  tot=pngs.length.to_s
  
pngs.each{|png|
  puts ctr+" of "+tot
  ctr.next!
  fpath=File.join(path, png)
  next if ! File.exist?(fpath)
  fpath.tr!("/","\\") if pc
  file=File.new(fromini, "w")
    file.write(fpath)
  file.close
  tpath=File.join(folder, png)
  File.delete(tpath) if File.exist?(tpath)
  tpath.tr!("/","\\") if pc
  file=File.new(toini, "w")
    file.write(tpath)
  file.close
  ###
  pwd=Dir.pwd
  Dir.chdir(dir)
    File.chmod(0777, jar) unless pc
    if jar[0].chr=="/"
        jar="file:#{jar}"
    else
        jar="file:/#{jar}"
    end#if
    UI.openURL(jar)###########################
  Dir.chdir(pwd)
  sleep(0.2)
  wait=0.0
  while ! File.exist?(tpath) && wait < 5.0
    sleep(0.2)
    wait=wait+0.2
  end#while
  sleep(0.2)
}

  ###
  UI.openURL("file:/#{folder}") ###############################
  ###
  File.delete(fromini) if File.exist?(fromini)
  File.delete(toini) if File.exist?(toini)
  ###
  return folder
  ###
end#def
###
